import { Map } from 'immutable';
import { Action, Dispatch } from 'redux';
import apiCall from './api';
import { ApiConfig, Locale, Messages, TranslationResult } from './types';
export interface StoredTranslation extends Map<string, string | TranslationResult> {
    data_type: string;
    key: string;
    text: TranslationResult;
}
export declare type StoredTranslations = Map<string, Map<string, StoredTranslation>>;
export default class Connector {
    currentLocation: string;
    config: ApiConfig;
    api: typeof apiCall;
    dispatch: Dispatch<Action>;
    translationStore: any;
    previousTranslationsSend: any;
    sendTimeout: any;
    locale: Locale;
    constructor(config: ApiConfig, dispatch: Dispatch<Action>, pathname?: string);
    updateLocation(location: string): void;
    rememberUsedTranslation(locale: Locale, path: string | string[], message: TranslationResult | Messages): void;
    sendTranslations(): void;
    __enqueeSendTranslations(): void;
    __rememberTranslation(keyPath: string[], message: TranslationResult | Messages): void;
    __listenOnTranslationServer(): void;
    __dataType(value: any): "string" | "bool" | "array" | "float" | null;
}
