import * as PropTypes from 'prop-types';
import * as React from 'react';
import Connector from './Connector';
import { Translator } from './translator';
import { ApiConfig } from './types';
export interface ProviderProps {
    config?: ApiConfig;
    pathname?: string;
    history?: any;
}
export interface ProviderState {
    historyUnsubscribe?: () => void;
}
export declare class Provider extends React.Component<ProviderProps, ProviderState> {
    static defaultProps: {
        config: {};
        pathname: string;
    };
    state: {
        historyUnsubscribe: undefined;
    };
    connector?: Connector;
    translator?: Translator;
    static contextTypes: {
        store: PropTypes.Requireable<any>;
    };
    static childContextTypes: {
        translator: () => void;
    };
    componentWillMount(): void;
    updateLocation: () => void;
    componentWillUpdate(nextProps: ProviderProps): void;
    getChildContext(): {
        translator: Translator;
    };
    render(): JSX.Element;
}
export default Provider;
