"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var PropTypes = require("prop-types");
var React = require("react");
var Connector_1 = require("./Connector");
var translator_1 = require("./translator");
var Provider = /** @class */ (function (_super) {
    __extends(Provider, _super);
    function Provider() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            historyUnsubscribe: undefined,
        };
        _this.connector = undefined;
        _this.translator = undefined;
        _this.updateLocation = function () {
            if (_this.connector) {
                _this.connector.updateLocation(window.location.pathname);
            }
        };
        return _this;
    }
    Provider.prototype.componentWillMount = function () {
        this.setState({
            historyUnsubscribe: this.props.history ? this.props.history.listen(this.updateLocation) : undefined,
        });
    };
    Provider.prototype.componentWillUpdate = function (nextProps) {
        if (nextProps.pathname && this.connector && nextProps.pathname !== this.props.pathname) {
            this.connector.updateLocation(nextProps.pathname);
        }
    };
    Provider.prototype.getChildContext = function () {
        var store = this.context.store;
        var _a = this.props, config = _a.config, pathname = _a.pathname;
        if (!this.connector) {
            var apiConfig = __assign({ apiEndpoint: 'api/v1/translations' }, config);
            this.connector = (config && config.sync)
                ? new Connector_1.default(apiConfig, store.dispatch, pathname)
                : undefined;
        }
        if (!this.translator) {
            this.translator = new translator_1.Translator(store, this.connector);
        }
        return {
            translator: this.translator,
        };
    };
    Provider.prototype.render = function () {
        return this.props.children;
    };
    Provider.defaultProps = {
        config: {},
        pathname: typeof window !== 'undefined' ? "" + window.location.pathname : '/',
    };
    Provider.contextTypes = {
        store: PropTypes.object,
    };
    Provider.childContextTypes = {
        translator: function () { },
    };
    return Provider;
}(React.Component));
exports.Provider = Provider;
exports.default = Provider;
//# sourceMappingURL=Provider.js.map