"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var immutable_1 = require("immutable");
var PropTypes = require("prop-types");
var React = require("react");
var react_1 = require("react");
var TestUtils = require("react-dom/test-utils");
var react_redux_1 = require("react-redux");
var redux_1 = require("redux");
var actions_1 = require("../actions");
var Provider_1 = require("../Provider");
var reducer_1 = require("../reducer");
var initial = {
    messages: immutable_1.fromJS({
        cs: { home: { description: 'Foo', fallback: 'Fallback' } },
        en: { home: { description: 'enFoo', about: 'Bar' } },
    }),
    locale: 'cs',
    fallbackLocale: 'en',
};
var store = redux_1.createStore(function (_a, action) { return ({ translate: reducer_1.default(initial, action) }); });
describe('Translate Provider', function () {
    var Passthrough = /** @class */ (function (_super) {
        __extends(Passthrough, _super);
        function Passthrough() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        Passthrough.prototype.render = function () {
            return React.createElement("div", null);
        };
        Passthrough.contextTypes = {
            translator: PropTypes.object,
        };
        return Passthrough;
    }(react_1.Component));
    var container = TestUtils.renderIntoDocument(React.createElement(react_redux_1.Provider, { store: store },
        React.createElement(Provider_1.default, null,
            React.createElement(Passthrough, null))));
    var stub = TestUtils.findRenderedComponentWithType(container, Passthrough);
    var translateCtx = stub.context.translator;
    it('should have a msg object in context', function () {
        expect(translateCtx.msg('description', { scope: 'home' })).toEqual('Foo');
    });
    it('should have a messages object in context', function () {
        expect(translateCtx.__messages().getIn(['cs', 'home', 'description'])).toEqual('Foo');
    });
    it('should change the selected locale', function () {
        store.dispatch(actions_1.changeLocale('en'));
        expect(translateCtx.msg('description', { scope: 'home' })).toEqual('enFoo');
    });
});
//# sourceMappingURL=Provider.spec.js.map