"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var createCnt_1 = require("../createCnt");
var benchmark = function (fn) {
    var start = new Date();
    for (var i = 0; i < 20000; i++) {
        fn(i);
    }
    return (new Date().getTime() - start.getTime());
};
var memoizedCreateCntSame = createCnt_1.memoizeCreateCnt(createCnt_1.createCnt);
var normalFn = function () { return createCnt_1.createCnt('en.foo.bar', 'result'); };
var memoizedFn = function () { return memoizedCreateCntSame('en.foo.bar', 'result'); };
var fasterByX = 5;
var memoizedCreateCntSeq = createCnt_1.memoizeCreateCnt(createCnt_1.createCnt);
var normalFnSeq = function (i) { return createCnt_1.createCnt("en.foo.bar." + i, 'result'); };
var memoizedFnSeq = function (i) { return memoizedCreateCntSeq("en.foo.bar." + i, 'result'); };
it('memoized version should be faster for same call', function () {
    expect(benchmark(memoizedFn)).toBeLessThan(benchmark(normalFn) / fasterByX);
});
it('memoized version should be slower for different calls', function () {
    expect(benchmark(memoizedFnSeq)).toBeGreaterThan(benchmark(normalFnSeq));
});
//# sourceMappingURL=createCnt.spec.js.map