"use strict";
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var immutable_1 = require("immutable");
var reducer_1 = require("../reducer");
var initial = __assign({}, reducer_1.initialState, { messages: immutable_1.fromJS({ cs: { home: { description: 'Foo' } } }) });
describe('translate reducer', function () {
    it('it should return initial state', function () {
        expect(reducer_1.default(undefined, { type: 'INIT', payload: '' })).toEqual(reducer_1.initialState);
    });
    it('it should revive state', function () {
        var state = reducer_1.default({ messages: { en: { foo: 'bar' } }, locale: 'en' }, { type: 'INIT', payload: '' });
        expect(immutable_1.Map.isMap(state.messages)).toEqual(true);
        expect(state.messages.getIn(['en', 'foo'])).toEqual('bar');
    });
    it('should change locale', function () {
        var action = {
            type: 'TRANSLATE_CHANGE_LOCALE',
            payload: 'es',
        };
        expect(reducer_1.default(undefined, action).locale).toEqual('es');
    });
    it('should update messages', function () {
        var messages = immutable_1.fromJS({
            cs: { home: { title: 'Bar' } },
            en: { home: { title: 'home', desciption: 'description' } },
        });
        var action = {
            type: 'TRANSLATE_UPDATE_MESSAGES',
            payload: messages,
        };
        expect(reducer_1.default(undefined, action).messages.toJS()).toEqual(messages.toJS());
        expect(reducer_1.default(initial, action).messages.getIn(['cs', 'home', 'description'])).toEqual('Foo');
        expect(reducer_1.default(initial, action).messages.getIn(['cs', 'home', 'title'])).toEqual('Bar');
    });
});
//# sourceMappingURL=reducer.spec.js.map