import { Action, Dispatch } from 'redux';
import { ApiConfig, Messages } from './types';
export interface TranslateAction extends Action {
    payload: string | Messages;
}
export declare const TRANSLATE_CHANGE_LOCALE = "TRANSLATE_CHANGE_LOCALE";
export declare const TRANSLATE_UPDATE_MESSAGES = "TRANSLATE_UPDATE_MESSAGES";
/**
 * Action for changing locale to display
 * @param {String}  locale name of locale
 * @return {Object}        declared action
 */
export declare function changeLocale(locale: string): TranslateAction;
/**
 * Action for updating locale messages
 * @param {Object}  messages format options
 * @return {Object}          declared action
 */
export declare function updateMessages(messages: Messages): TranslateAction;
/**
 * Action for updating locale messages
 * @param {Object}  config configuration options
 * @return {Object}        declared action
 */
export declare function fetchTranslations(config: ApiConfig): (dispatch: Dispatch<Action<any>>) => Promise<any>;
