"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var immutable_1 = require("immutable");
var React = require("react");
var classifyKey_1 = require("./classifyKey");
exports.createCnt = function (key, result, onClick) {
    var Cnt = /** @class */ (function (_super) {
        __extends(Cnt, _super);
        function Cnt() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.onClick = function () {
                if (onClick) {
                    onClick(key, _this);
                }
            };
            return _this;
        }
        Cnt.prototype.render = function () {
            var _a = this.props, content = _a.content, usedKey = _a.usedKey;
            if (!content) {
                return null;
            }
            return (React.createElement("span", { "data-key": key, onClick: this.onClick, className: "cnt " + classifyKey_1.classifyKey(usedKey), dangerouslySetInnerHTML: { __html: "" + content } }));
        };
        return Cnt;
    }(React.Component));
    var cntInstace = (React.createElement(Cnt, { key: key, content: result, usedKey: key }));
    return __assign({}, cntInstace, { toString: function () { return result; } });
};
exports.memoizeCreateCnt = function (fn) {
    var memoizeCache = immutable_1.Map();
    return function (key, result, onClick) {
        if (memoizeCache.hasIn([key, result])) {
            return memoizeCache.getIn([key, result]);
        }
        var newResult = fn(key, result, onClick);
        memoizeCache = memoizeCache.setIn([key, result], newResult);
        return newResult;
    };
};
exports.default = exports.memoizeCreateCnt(exports.createCnt);
//# sourceMappingURL=createCnt.js.map