import { Map } from 'immutable';
import * as React from 'react';
import { StoredTranslation } from '../Connector';
import { EditorProps, EditorState, SortedKeys } from './types';
export declare class Editor extends React.PureComponent<EditorProps, EditorState> {
    state: {
        pendingChanges: Map<string, string>;
        sortedKeys: Map<string, StoredTranslation>;
    };
    componentWillReceiveProps(next: EditorProps): void;
    onChange: (keyPath: string, originalText: string) => ({ target: { value } }: any) => void;
    sortAndFilterKeys(search: string): SortedKeys;
    updateTranslation: (key: string, text: string, keyPath: string) => void;
    renderTranslation: (data: StoredTranslation) => JSX.Element | null;
    render(): JSX.Element;
}
declare const _default: typeof Editor;
export default _default;
