"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var Panel_1 = require("./Panel");
var TranslationEditor_1 = require("./TranslationEditor");
var SignIn = /** @class */ (function (_super) {
    __extends(SignIn, _super);
    function SignIn() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            email: '',
            password: '',
        };
        _this.onFieldChange = function (_a) {
            var _b = _a.target, name = _b.name, value = _b.value;
            var _c;
            _this.setState((_c = {}, _c[name] = value, _c));
        };
        _this.onSubmit = function (event) {
            event.preventDefault();
            var _a = _this.props, apiCall = _a.apiCall, setError = _a.setError, setUser = _a.setUser;
            apiCall('post', '/api_frontend/v1/login', { user: _this.state }).then(function (data) {
                if (data.error) {
                    setError(data.error);
                }
                else {
                    setUser(data.user);
                }
            });
        };
        return _this;
    }
    SignIn.prototype.render = function () {
        var _a = this.state, email = _a.email, password = _a.password;
        var error = this.props.error;
        return (React.createElement(Panel_1.default, { error: error },
            React.createElement("form", { onSubmit: this.onSubmit },
                React.createElement("label", { htmlFor: "email", style: TranslationEditor_1.style.label }, "Email"),
                React.createElement("input", { type: "email", name: "email", value: email, onChange: this.onFieldChange, style: TranslationEditor_1.style.input }),
                React.createElement("label", { htmlFor: "password", style: TranslationEditor_1.style.label }, "Password"),
                React.createElement("input", { type: "password", name: "password", value: password, onChange: this.onFieldChange, style: TranslationEditor_1.style.input }),
                React.createElement("div", null,
                    React.createElement("button", { style: TranslationEditor_1.style.button }, "Sign In")))));
    };
    return SignIn;
}(React.PureComponent));
exports.default = SignIn;
//# sourceMappingURL=SignIn.js.map