import * as React from 'react';
import { UpdateTranslation } from './TranslationEditor';
import { PendingChanges } from './types';
export interface EditorProps {
    value: string | number;
    onChange: (x: any) => void;
}
export interface TranslationProps {
    opened: boolean;
    onChange: (keyPath: string, text: string) => (x: {
        target: {
            value?: string | number;
            keyPath: string;
        };
    }) => void;
    dataType?: string | number;
    keyPath: string;
    pendingChanges: PendingChanges;
    text: string;
    updateTranslation: UpdateTranslation;
}
export interface TranslationState {
    opened: boolean;
}
export declare class Translation extends React.PureComponent<TranslationProps, TranslationState> {
    state: {
        opened: boolean;
    };
    save: () => void;
    restore: () => void;
    key(): string[];
    render(): JSX.Element;
}
declare const _default: typeof Translation;
export default _default;
