"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var radium_1 = require("radium");
var React = require("react");
var classifyKey_1 = require("../classifyKey");
var TranslationEditor_1 = require("./TranslationEditor");
var StringEditor = function (_a) {
    var value = _a.value, onChange = _a.onChange;
    return (React.createElement("textarea", { style: [TranslationEditor_1.style.input, { minHeight: '70px', marginBottom: '5px' }], value: value || '', onChange: onChange }));
};
var NumberEditor = function (_a) {
    var value = _a.value, onChange = _a.onChange;
    return (React.createElement("input", { type: "number", style: TranslationEditor_1.style.input, value: value || '', onChange: onChange }));
};
var BoolEditor = function (_a) {
    var inputValue = _a.value, onChange = _a.onChange;
    return (React.createElement("input", { type: "checkbox", style: TranslationEditor_1.style.input, value: inputValue || 'false', onChange: function (_a) {
            var value = _a.target.checked;
            return onChange({ target: { value: value } });
        } }));
};
var mapping = {
    string: radium_1.default(StringEditor),
    number: radium_1.default(NumberEditor),
    bool: radium_1.default(BoolEditor),
};
var Translation = /** @class */ (function (_super) {
    __extends(Translation, _super);
    function Translation() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            opened: false,
        };
        _this.save = function () {
            var _a = _this.props, keyPath = _a.keyPath, text = _a.text, updateTranslation = _a.updateTranslation;
            updateTranslation(_this.key().join('.'), text, keyPath);
        };
        _this.restore = function () {
            var _a = _this.props, keyPath = _a.keyPath, text = _a.text, pendingChanges = _a.pendingChanges, onChange = _a.onChange;
            if (pendingChanges.has(keyPath)) {
                onChange(keyPath, text)({ target: { value: pendingChanges.get(keyPath), keyPath: keyPath } });
            }
        };
        return _this;
    }
    Translation.prototype.key = function () {
        var keyPath = this.props.keyPath;
        return keyPath.split('.').splice(1);
    };
    Translation.prototype.render = function () {
        var _this = this;
        var _a;
        var opened = this.state.opened;
        var _b = this.props, dataType = _b.dataType, keyPath = _b.keyPath, text = _b.text, onChange = _b.onChange, pendingChanges = _b.pendingChanges;
        var EditorComponent = mapping[dataType || 'string'];
        var changed = pendingChanges.has(keyPath);
        return (React.createElement("div", { key: "hovering", style: [styles.wrapper, changed && styles.changed] },
            React.createElement("strong", { key: this.key().join('.'), style: styles.key, onClick: function () { return (_this.setState({ opened: !opened })); } }, this.key().join('.')),
            (opened || this.props.opened) && React.createElement(EditorComponent, { value: text, onChange: onChange(keyPath, text) }),
            radium_1.default.getState(this.state, 'hovering', ':hover') &&
                React.createElement(radium_1.default.Style, { rules: (_a = {}, _a["." + classifyKey_1.classifyKey(this.key().join('.'))] = { background: 'red' }, _a) }),
            changed && React.createElement("button", { onClick: this.save, style: TranslationEditor_1.style.button, key: this.key() + "Save" }, "Save"),
            changed && React.createElement("button", { onClick: this.restore, style: [TranslationEditor_1.style.button, styles.buttonSecondary], key: this.key() + "Restore" }, "Restore")));
    };
    return Translation;
}(React.PureComponent));
exports.Translation = Translation;
var styles = {
    wrapper: {
        ':hover': {},
    },
    changed: {
        background: 'yellow',
    },
    buttonSecondary: {
        marginLeft: '10px',
        border: "1px solid #555",
        backgroundColor: '#555',
        ':hover': {
            border: '1px solid #111111',
        },
    },
    key: {
        display: 'block',
        marginBottom: '3px',
        ':hover': {
            cursor: 'pointer',
        },
    },
};
exports.default = radium_1.default(Translation);
//# sourceMappingURL=Translation.js.map