import * as moment from 'moment';
export interface FormatOptions {
    precision?: number;
    delimiter?: string;
    format?: string;
    separator?: string;
    template?: string;
    unit?: string;
    trimTrailingZeros?: boolean;
}
export interface DefaultFormatOptions {
    precision: number;
    delimiter: string;
    format: string;
    separator: string;
    template: string;
    unit: string;
    trimTrailingZeros: boolean;
}
export declare type GivenDate = Date | moment.Moment | string;
export declare const defaultDateFormat = "D.M.YYYY";
export declare const defaultOptions: DefaultFormatOptions;
export declare function mergeOptionsWithDefault(givenOptions: FormatOptions): DefaultFormatOptions;
export declare function formatDate(givenDate: GivenDate, locale: string, format?: string): string;
export declare function formatNumber(input: number, givenOptions?: FormatOptions): string;
export declare function formatCurrency(input: number, givenOptions?: FormatOptions): string;
export declare function formatNumberSeparatorAndDelimiter(input: number, givenOptions?: FormatOptions): string;
export declare function roundNumber(input: number, givenOptions: FormatOptions): number;
