"use strict";
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var immutable_1 = require("immutable");
var actions = require("./actions");
exports.initialState = {
    locale: 'en',
    fallbackLocale: 'en',
    messages: immutable_1.fromJS({}),
};
/**
 * Translation Redux reducer
 * @param  {Object} inputState  App state
 * @param  {Object} action      Flux action
 * @return {Object}             Updated app state
 */
function translationReducer(state, action) {
    if (state === void 0) { state = exports.initialState; }
    // Revive state if messages are not immutable Map
    if (!immutable_1.Map.isMap(state.messages)) {
        return __assign({}, exports.initialState, state, { messages: immutable_1.fromJS(state.messages) });
    }
    switch (action.type) {
        case actions.TRANSLATE_CHANGE_LOCALE: return __assign({}, state, { locale: action.payload });
        case actions.TRANSLATE_UPDATE_MESSAGES:
            return __assign({}, state, { messages: state.messages.mergeDeep(action.payload) });
        default: return state;
    }
}
exports.translationReducer = translationReducer;
exports.default = translationReducer;
//# sourceMappingURL=reducer.js.map