"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var _this = this;
Object.defineProperty(exports, "__esModule", { value: true });
var fs = require("fs");
var nock = require("nock");
var path = require("path");
var fetchRelease_1 = require("../fetchRelease");
describe('fetchRelease()', function () {
    var releasesDir = path.join(__dirname, 'test_fetch_release');
    var config = { apiToken: 'X', apiUrl: 'http://translation.cz', apiEndpoint: 'api/v1/releases', releasesDir: releasesDir };
    // afterEach(() => {
    //   try {
    //     fs.accessSync(path.join(releasesDir, 'cs.json'), fs['F_OK']);
    //   } catch (e) {
    //   }
    // });
    nock('http://translation.cz', {
        reqheaders: {
            Authorization: 'Token token=X',
            'Content-type': 'application/json',
        },
    }).get('/api/v1/releases/cs_v001.json')
        .reply(200, { cs: { foo: 'Bar' } });
    nock('http://translation.cz', {
        reqheaders: {
            Authorization: 'Token token=X',
            'Content-type': 'application/json',
        },
    }).get('/api/v1/releases/unknown_v001.json')
        .reply(404, {
        errors: 'Not Found',
        message: 'Release could not be found by version: unknown_v001',
    });
    it('calls API with know version', function () { return __awaiter(_this, void 0, void 0, function () {
        var result;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, fetchRelease_1.default(config, 'cs_v001')];
                case 1:
                    result = _a.sent();
                    expect(result).toEqual({ cs: { foo: 'Bar' } });
                    expect(JSON.parse(fs.readFileSync(path.join(releasesDir, 'cs.json')).toString()))
                        .toEqual(JSON.parse(fs.readFileSync(path.join(__dirname, 'fixture_cs.json')).toString()));
                    return [2 /*return*/];
            }
        });
    }); });
    it('throw error without config releasesDir', function () { return __awaiter(_this, void 0, void 0, function () {
        var e_1;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    _a.trys.push([0, 2, , 3]);
                    return [4 /*yield*/, fetchRelease_1.default({}, 'unknown_v001')];
                case 1:
                    _a.sent();
                    expect(true).toBeFalsy();
                    return [3 /*break*/, 3];
                case 2:
                    e_1 = _a.sent();
                    expect(e_1.message).toContain('Missing');
                    return [3 /*break*/, 3];
                case 3: return [2 /*return*/];
            }
        });
    }); });
    it('throw error without existing releasesDir', function () { return __awaiter(_this, void 0, void 0, function () {
        var e_2;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    _a.trys.push([0, 2, , 3]);
                    return [4 /*yield*/, fetchRelease_1.default({ releasesDir: path.join(process.cwd(), 'unknownDirectory') }, 'unknown_v001')];
                case 1:
                    _a.sent();
                    expect(true).toBeFalsy();
                    return [3 /*break*/, 3];
                case 2:
                    e_2 = _a.sent();
                    expect(e_2.message).toContain('Cannot continue:');
                    return [3 /*break*/, 3];
                case 3: return [2 /*return*/];
            }
        });
    }); });
    it('throw error on call API without version', function () { return __awaiter(_this, void 0, void 0, function () {
        var e_3;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    _a.trys.push([0, 2, , 3]);
                    return [4 /*yield*/, fetchRelease_1.default(config, 'unknown_v001')];
                case 1:
                    _a.sent();
                    expect(true).toBeFalsy();
                    return [3 /*break*/, 3];
                case 2:
                    e_3 = _a.sent();
                    expect(e_3.message).toContain('404');
                    return [3 /*break*/, 3];
                case 3: return [2 /*return*/];
            }
        });
    }); });
});
//# sourceMappingURL=fetchRelease.spec.js.map