import * as React from 'react';
import { FormatDate, FormatNumber, Msg, Resolve, Translator } from './translator';
import { Messages, MsgOptions, TranslationResult } from './types';
export declare type TextFunc = (key: string, options?: MsgOptions) => string;
export declare type CntFunc = (key: string, options?: MsgOptions) => JSX.Element;
export declare type HasMsgFunc = (key: string, options?: MsgOptions) => boolean;
export interface TranslateProps {
    cnt: CntFunc;
    msg: CntFunc;
    text: Msg;
    hasMsg: HasMsgFunc;
    resolveMsg: Resolve;
    formatDate: FormatDate;
    formatNumber: FormatNumber;
    formatCurrency: FormatNumber;
    formatPercentage: FormatNumber;
    translator: Translator;
    translateLocale: () => string;
    translateMessages: () => Messages;
}
export interface TranslateState {
    locale: string | null;
    messages: TranslationResult | null;
    fallbackLocale: string | null;
    unsubscribeStore: () => void;
}
export declare type TranslateDecorator<P> = (WrappedComponent: React.ComponentClass<P & TranslateProps>) => React.ComponentClass<P>;
export declare function translate<P>(scope?: string | string[], overrides?: MsgOptions): TranslateDecorator<P>;
export default translate;
