"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var PropTypes = require("prop-types");
var React = require("react");
var createCnt_1 = require("./createCnt");
function translate(scope, overrides) {
    return function (WrappedComponent) {
        var _a;
        return _a = /** @class */ (function (_super) {
                __extends(Translate, _super);
                function Translate() {
                    var _this = _super !== null && _super.apply(this, arguments) || this;
                    _this.state = {
                        locale: null,
                        messages: null,
                        fallbackLocale: null,
                        unsubscribeStore: function () { },
                    };
                    _this.updateState = function () {
                        var store = _this.context.store;
                        var _a = store.getState().translate, locale = _a.locale, fallbackLocale = _a.fallbackLocale, messages = _a.messages;
                        _this.setState({ messages: messages, locale: locale, fallbackLocale: fallbackLocale });
                    };
                    _this.resolveMsg = function (key, givenOptions) {
                        if (givenOptions === void 0) { givenOptions = {}; }
                        var options = givenOptions || {};
                        var translator = _this.context.translator;
                        var wantedScope = []
                            .concat(scope || [], options.scope || [])
                            .filter(function (x) { return !!x; })
                            .join('.');
                        return translator.resolve(key, __assign({}, options, overrides, { scope: wantedScope }));
                    };
                    // tslint:disable-next-line:typedef
                    _this.text = function (key, options) {
                        if (options === void 0) { options = {}; }
                        return "" + _this.resolveMsg(key, options).result;
                    };
                    // tslint:disable-next-line:typedef
                    _this.cnt = function (key, options) {
                        if (options === void 0) { options = {}; }
                        return _this.msg(key, options);
                    };
                    // tslint:disable-next-line:typedef
                    _this.msg = function (key, options) {
                        if (options === void 0) { options = {}; }
                        var translator = _this.context.translator;
                        var _a = _this.resolveMsg(key, options), result = _a.result, usedKey = _a.usedKey;
                        return createCnt_1.default(usedKey, result, translator.onMsgClick);
                    };
                    _this.hasMsg = function (key, options) {
                        if (options === void 0) { options = {}; }
                        var result = _this.resolveMsg(key, __assign({}, options, { disableDefault: true })).result;
                        return !!result && ("" + result).length > 0;
                    };
                    return _this;
                }
                Translate.prototype.componentWillMount = function () {
                    var store = this.context.store;
                    if (!store) {
                        return;
                    }
                    this.setState({
                        unsubscribeStore: store.subscribe(this.updateState),
                    });
                    this.updateState();
                };
                Translate.prototype.componentWillUnmount = function () {
                    var unsubscribeStore = this.state.unsubscribeStore;
                    if (unsubscribeStore) {
                        unsubscribeStore();
                    }
                };
                Translate.prototype.getTranslateMethods = function () {
                    var translator = this.context.translator;
                    var _a = translator, formatDate = _a.formatDate, formatCurrency = _a.formatCurrency, formatNumber = _a.formatNumber, formatPercentage = _a.formatPercentage;
                    return {
                        cnt: this.cnt,
                        msg: this.msg,
                        text: this.text,
                        hasMsg: this.hasMsg,
                        resolveMsg: this.resolveMsg,
                        formatDate: formatDate,
                        formatNumber: formatNumber,
                        formatCurrency: formatCurrency,
                        formatPercentage: formatPercentage,
                        translator: translator,
                        translateLocale: translator.__locale(),
                        translateMessages: translator.__messages(),
                    };
                };
                Translate.prototype.render = function () {
                    return (React.createElement(WrappedComponent, __assign({}, this.getTranslateMethods(), this.props)));
                };
                return Translate;
            }(React.PureComponent)),
            _a.displayName = "Translate(" + (WrappedComponent && (WrappedComponent.displayName || WrappedComponent.name) || 'Component') + ")",
            _a.contextTypes = {
                store: PropTypes.object,
                translator: PropTypes.object,
            },
            _a;
    };
}
exports.translate = translate;
exports.default = translate;
//# sourceMappingURL=translate.js.map